/*
 * $Id: link.c,v 1.4 1995/07/30 15:09:44 miura Exp $
 */

#include <windows.h>
#include <wchar.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include "config.w32"

static char rcsid[] = "$Id: link.c,v 1.4 1995/07/30 15:09:44 miura Exp $";


static BOOL
get_path (LPWSTR pszDest, DWORD cch, LPCTSTR pszFile, BOOL fMakeDir)
{
  DWORD cb;
  WCHAR szTemp[MAX_PATH + 1];
  LPCWSTR pszFrom;
  LPWSTR lpstr;
  BOOL fOk;

  if ( _tcslen (pszFile) > MAX_PATH )
    return FALSE;

#if !defined (UNICODE) && !defined (_UNICODE)
  wsprintfW (szTemp, L"%hs", pszFile);
  pszFrom = szTemp;
#else
  pszFrom = pszFile;
#endif

  cb = GetFullPathNameW (pszFrom, cch, pszDest, &lpstr);
  fOk = cb != 0  &&  cb <= cch;
  if (fOk && fMakeDir)
    {
      static WCHAR seps[] = L"\\/";
      LPWSTR p;
      for (p = pszDest + wcscspn (pszDest, seps);
	   p < lpstr && *p;
	   ++p, p += wcscspn (p,seps))
        {
	  WCHAR sep = *p;
	  *p = '\0';
	  CreateDirectoryW (pszDest, NULL);
	  *p = sep;
        }
    }

  return fOk;
}


int
link (LPCTSTR pszFrom, LPCTSTR pszTo)
{                     
  WCHAR szFileFrom[MAX_PATH + 1];
  WCHAR szFileTo[MAX_PATH + 1];
  HANDLE hFile;
  DWORD cbName;
  WIN32_STREAM_ID id;
  LPVOID lpContext = NULL;
  DWORD cbWrote;
  BOOL fSuccess;
    
  if (!get_path (szFileFrom, sizeof (szFileFrom) / sizeof (WCHAR),
		 pszFrom, FALSE)
      || !get_path (szFileTo, sizeof (szFileTo) / sizeof (WCHAR),
		    pszTo, TRUE))
    return -1;

  hFile = CreateFileW (szFileFrom, GENERIC_READ,
		       FILE_SHARE_READ | FILE_SHARE_WRITE,
		       NULL, OPEN_EXISTING,
		       FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN
		       | FILE_FLAG_BACKUP_SEMANTICS, NULL);
  if (hFile == INVALID_HANDLE_VALUE)
    return -1;

  cbName = (wcslen (szFileTo) + 1) * sizeof (WCHAR);

  id.dwStreamId         = BACKUP_LINK;
  id.dwStreamAttributes = 0;
  id.Size.LowPart       = cbName;
  id.Size.HighPart      = 0;
  id.dwStreamNameSize   = 0;

  fSuccess = BackupWrite (hFile, (LPBYTE) &id,
			  (LPBYTE) &id.cStreamName - (LPBYTE) &id,
			  &cbWrote, FALSE, FALSE, &lpContext)
    && (cbWrote == (DWORD)((LPBYTE) &id.cStreamName - (LPBYTE) &id))
      && BackupWrite (hFile, (LPBYTE) szFileTo, cbName, &cbWrote,
		      FALSE, FALSE, &lpContext);
  fSuccess = BackupWrite (hFile, NULL, 0, &cbWrote, TRUE, FALSE, &lpContext)
    && fSuccess;

  CloseHandle (hFile);

  return fSuccess ? 0 : -1;
}


int
main (int argc, char **argv)
{
  strcpy(argv[0], "ln");
  if (argc == 3)
      link (argv[1], argv[2]);
  else
    printf ("Usage: %s from to\n", argv[0]);
  return 0;
}
