/*
 * $Id: ndir.h,v 1.3 1995/09/23 05:51:11 miura Exp $
 *
 * ndir.c -- portable directory routines
 * Copyright (c) 1995, Shigeki Miura <miura@rpts.cl.nec.co.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _NDIR_H
#define _NDIR_H

#include <tchar.h>
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

#define MAXNAMLEN	_MAX_PATH

#define d_ino	d_fileno

struct direct
{
  unsigned int d_attrib;

  unsigned long d_fileno;
  unsigned short d_reclen;
  unsigned short d_namlen;
  _TCHAR d_name[MAXNAMLEN + 1];
};


typedef struct
{
  void *dd_fd;
  long dd_loc;
  _TCHAR dd_name[MAXNAMLEN + 1];
} DIR;


DIR *opendir (const _TCHAR *);
void closedir (DIR *);
struct direct *readdir (DIR *);
void rewinddir (DIR *);
long telldir (DIR *);
void seekdir (DIR *, long);

#ifdef __cplusplus
}
#endif

#endif /* _NDIR_H */
